#!/usr/bin/env python
# -*- coding: utf-8 -*-

# twisted import
from twisted.python import log

# nevow import
from nevow.i18n import _

# bewype component import
from bewype.core.component.menu.menu import Menu

def _css_dict():
    _key_dict = dict()

    # menu
    _key_dict["menu_img_grad_url"] = "#"
    _key_dict["menu_background_color"] = "#eee"
    _key_dict["menu_border_color"] = "#aaa"
    #
    _key_dict["menu_horizontal_padding"] = 20
    _key_dict["menu_horizontal_align"] = "left"
    #
    _key_dict["menu_font_family"] = \
            "Tahoma, Verdana, Arial, Helvetica, sans-serif"
    _key_dict["menu_font_style"] = "normal"
    _key_dict["menu_font_size"] = 16

    # ul
    _key_dict["menu_ul_text_color"] = "#444"
    _key_dict["menu_ul_text_color_hover"] = "#000"
    #
    _key_dict["menu_ul_padding_vertical"] = 10
    _key_dict["menu_ul_padding_horizontal"] = 12

    # ul hover
    _key_dict["menu_ul_bg_color_hover"] = "#ff9"
    _key_dict["menu_ul_border_side_color_hover"] = "#fc0"
    #
    _key_dict["menu_ul_border_top_color_hover"] = "transparent"
    _key_dict["menu_ul_border_bottom_color_hover"] = "#eee"

    # dir
    _key_dict["menu_img_arrow_down_url"] = "#"

    # dir hover
    _key_dict["menu_ul_dir_border_top_color_hover"] = "#f60"

    # ul ul
    _key_dict["menu_ul_ul_width"] = 150
    _key_dict["menu_ul_ul_bg_color"] = "#00f"

    # ul ul hover
    _key_dict["menu_ul_ul_bg_color_hover"] = "#c9f"
    _key_dict["menu_ul_ul_border_left_color_hover"] = "#063"

    # ul ul dir
    _key_dict["menu_ul_ul_dir_bg_color"] = "#f00"
    _key_dict["menu_img_arrow_right_url"] = ""

    # ul ul dir hover
    _key_dict["menu_ul_ul_dir_bg_color_hover"] = "#fc9"
    _key_dict["menu_ul_ul_dir_border_left_color_hover"] = "#960"

    # ul ul ul
    _key_dict["menu_ul_ul_ul_bg_color"] = "#0f0"

    # ul ul ul hover
    _key_dict["menu_ul_ul_ul_bg_color_hover"] = "#cf9"
    _key_dict["menu_ul_ul_ul_border_left_color_hover"] = "#360"
    # do return
    return _key_dict

class MenuHorizontal(Menu):

    def add_static_resources(self):
        Menu.add_static_resources(self, file_=__file__)

    def get_css_dict(self):
        return _css_dict()

