#!/usr/bin/env python
# -*- coding: utf-8 -*-

# python import
from datetime import datetime
# twisted import
from twisted.python import log

# nevow import
from nevow import tags as T
from nevow.i18n import _

# bewype ui import
from bewype.core import ui
# bewype component import
from bewype.core.component.component import Component

class Title(Component):

    def get_value_key(self):
        return None

    def get_field(self, item):
        """Return a simple label with h1 tag. Use the component label attribute
        as text value.

        :params item: not used for a basic component
        """
        return ui.Label(class_=self.class_, text=self._label, tag=T.h1)

