#!/usr/bin/env python
# -*- coding: utf-8 -*-

# python import
from functools import partial

# twited import
from twisted.python import log

# bewype ui import
from bewype.core.ui.widget import Widget

def get_attr_factory(widget):
    """
    """
    if hasattr(widget, "get_docFactory"):
        return widget.get_docFactory()
    else:
        return widget

# Container
class Container(Widget):

    def __init__(self, id_=None, class_=None, border_width=None):
        """
        """
        #
        Widget.__init__(self, id_=id_, class_=class_)
        #
        self.border_width = border_width

    def get_docFactory(self):
        """
        """
        #
        if len(self.widgets) > 0:
            return map(get_attr_factory, self.widgets)
        else:
            return self.docFactory

    def set_border_width(self, border_width):
        """
        """
        self.border_width = border_width

    def get_border_width(self):
        """
        """
        return self.border_width
    
    def pack_start(self, widget):
        """
        """
        # add item to the container
        self.widgets.insert(0, widget)
        
    def pack_end(self, widget):
        """
        """
        # add item to the container
        self.widgets.append(widget)

    def pack_start_defaults(self, widget):
        """
        """
        self.pack_start(widget)

    def pack_end_defaults(self, widget):
        """
        """
        self.pack_end(widget)

    def add(self, widget):
        """
        """
        #
        if hasattr(widget, "set_parent"):
            widget.set_parent(self)
        else:
            pass
        #
        if hasattr(widget, "set_page"):
            widget.set_page(self.page)
        else:
            pass
        #
        self.pack_end(widget)

    def remove(self, widget):
        """
        """
        self.widgets.remove(widget)

    def get_children(self):
        """
        """
        return self.widgets

    def set_focus_child(self, child):
        """
        """
        pass

    def get_focus_child(self):
        """
        """
        pass

    def resize_children(self):
        """
        """
        pass

    def child_set_property(self, child, property_name, value):
        """
        """
        pass

    def child_get_property(self, child, property_name):
        """
        """
        pass

