#!/usr/bin/env python
# -*- coding: utf-8 -*-

# nevow import
from nevow import tags as T
from nevow.i18n import _

# bewype ui import
from bewype.core.ui.entry import Entry

class Picker(Entry):

    def __init__(self, id_=None, class_=None, label=None, value=None,
            max_length=None, markup=None):
        """
        """
        # init parent
        Entry.__init__(self, id_=id_, class_=class_, max_length=max_length,
                value=value, markup=markup, readonly=True)
        # set picker default label
        self.label = label

class PickerButton(Picker):

    def get_docFactory(self):
        # get entry factory
        _entry = Entry.get_docFactory(self)
        # add button picker
        _button = T.input(type="submit", id="%sButton" % self.id_,
                class_=self.class_, value=self.label, alt=self.markup)
        # return the all
        return _entry, _button

class PickerImage(Picker):

    def get_docFactory(self):
        # get entry factory
        _entry = Entry.get_docFactory(self)
        # ensure good background
        _sylte = "background-color: %s" % "#ffffff" \
                if self.value is None else self.value
        _img = T.div(id_="%sDiv" % self.id_)[
                T.div(style=_sylte)
                ]
        # return the all
        return _entry, _img

