
/**
 *
 */
BewypeJS.Component.DatePicker = new Class(
{
    // parent class
    Extends: BewypeJS.Component,

   /**
     *
     */
    initialize: function (widgetName, widgetId, groupId, valueKey, dateFormat)
    {
        // init parent
        this.actionList = ["Add", "Cancel", "Edit", "Update", "Reload"];
        this.parent(widgetName, widgetId, groupId, valueKey);
        // set specific field id
        this.fieldId = this.widgetId + "PickerButton";
        // get date picker
        this.datePicker = this._getDatePicker();
        // ensure format
        this.dateFormat =
                MochiKit.Base.isUndefinedOrNull(dateFormat)
                ? "yyyy/m/d"
                : dateFormat;
    },

    _onChange: function (newDateStr)
    {
        // get current
        var _currentValue = BewypeJS.Utils.getFieldValue(this.fieldId);
        // get date obj
        var _newDateObj = MochiKit.DateTime.isoDate(newDateStr);
        // get formatted date string
        var _newValue = Other.DateFormat.formatDate(_newDateObj, this.dateFormat);
        //
        if(_currentValue != _newValue)
        {
            // set value
            BewypeJS.Utils.updateField(this.fieldId, _newValue);
            // close
            this.datePicker.DatePickerHide();
        }
    },

    _getDatePicker: function ()
    {
        // get date picker params
        var _pickerParams =  {
                date: new Date(),
                current: new Date(),
                calendars: 1,
                starts: 1,
                onChange: this._onChange
        };
        // create new picker in calendar element
        return jQuery("#" + this.fieldId + "Button").DatePicker(_pickerParams);
    },

    ////

    resultCb: function (linkElement, params, result)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        // get content
        var _value = BewypeJS.Utils.getVal(result, this.valueKey);
        //
        if (MochiKit.Base.isUndefinedOrNull(_action)
            || MochiKit.Base.isUndefinedOrNull(_value))
        {
            // ?? pass
        }
        else if(_action == "Cancel"
                || _action == "Edit"
                || _action == "Reload")
        {
            // set value
            BewypeJS.Utils.updateField(this.fieldId, _value[0]);
            //
            var _dateVal = null;
            _dateVal = MochiKit.Base.isUndefinedOrNull(_value[1])
                ? new Date()
                : MochiKit.DateTime.isoDate(_value[1]);
            // update cal
            this.datePicker.DatePickerSetDate(_dateVal, true);
        }
        else
        {
            // pass // nothing to do
        }
    }
});

