
/**
 *
 */
BewypeJS.Component.FilePicker = new Class(
{
    // parent class
    Extends: BewypeJS.Component,

   /**
     *
     */
    initialize: function (widgetName, widgetId, groupId, valueKey)
    {
        // init parent
        this.actionList = ["Add", "Cancel", "Edit", "Reload", "Update", "Upload"];
        this.parent(widgetName, widgetId, groupId, valueKey);
        // set specific field id
        this.fieldId = this.widgetId + "PickerButton";
        // get file uploader
        this.fileUploader = this._getFileUploader();
    },

    //// UPLOADER STUFF

    _onUploadChange: function (filename, ext)
    {
        // set content
        BewypeJS.Utils.updateField(this.fieldId, filename);
    },

    _getUploadParams: function()
    { 
        // add info
        var _itemId = this._getItemId();
        //
        if(MochiKit.Base.isUndefinedOrNull(_itemId))
        {
            // cancel upload
            return null;
        }
        else
        {
            // init params
            return {
                "itemId": _itemId,
                "action": "Upload",
            };
        }
    },

    _onUploadSubmit: function (filename, ext)
    {
        // add info
        var _params = this._getUploadParams();
        //
        if(MochiKit.Base.isUndefinedOrNull(_params))
        {
            // cancel upload
            return false;
        }
        else
        {
            // update params
            _params[this.valueKey] = filename;
            // _params["ext"] = ext;
            // update uploader params
            this.fileUploader.setData(_params);
        }
    },

    _resultAdapter: function (filename, result)
    {
        // default params
        var _params = this._getUploadParams();
        // call main cb
        this.resultCallBack(null, _params, result);
    },

    /**
     *
     */
    _getFileUploader: function ()
    {
        // set uploader action
        var _rpcUrl = BewypeJS.Utils.getRpcUrl(this.widgetId + "Upload");
        // prepare UpLoader Params
        var _settings = {
                "action": _rpcUrl,
                "autoSubmit": false,
                "responseType": "json",
                "onChange": this._onUploadChange,
                "onSubmit": this._onUploadSubmit,
                "onComplete": this._resultAdapter
            };
        // init Ajax Handler
        return new AjaxUpload(this.fieldId + "Button", _settings);
    },

    ////

    paramsCb: function (linkElement, params)
    {
        // get current action first
        var _action = BewypeJS.Utils.getVal(params, "action");
        //
        if (MochiKit.Base.isUndefinedOrNull(_action))
        {
            return null;
        }
        else if(_action == "Add")
        {
            // trigger upload manually here
            this.fileUploader.submit();
            return null;
        }
        else if(_action == "Update")
        {            
            // trigger upload manually here
            this.fileUploader.submit();
            return null;
        }
        else if (_action == "Cancel")
        {
            this.fileUploader._clearInput();
            return null;
        }
        else
        {
            // pass // nothing to do
        }
        // always return the params dict for the rpc call
        return params;
    }
});

