
/**
 *
 */
BewypeJS.Ui.ButtonBoxParser =
{
    parse: function (boxType, elementId)
    {
        var _params = BewypeJS.Ui.WidgetParser._parse(elementId);
        
        if(MochiKit.Base.isUndefinedOrNull(_params))
        {
            return null;
        }
        else
        {
            if(boxType == "horizontal")
            {
                // return new hbox
                return new BewypeJS.Ui.HButtonBox(_params);
            }
            else
            {
                // return new vbox
                return new BewypeJS.Ui.VButtonBox(_params);
            }
        }
    },

    swap: function (elementId, widget)
    {
        BewypeJS.Ui.WidgetParser.swap(elementId, widget);
    }
};

/**
 *
 */
BewypeJS.Ui.HButtonBoxParser =
{
    parse: function (elementId)
    {
        // use parent parser
        return BewypeJS.Ui.ButtonBoxParser.parse("horizontal", elementId);
    },

    swap: function (elementId, widget)
    {
        BewypeJS.Ui.ButtonBoxParser.swap(elementId, widget);
    }
};

/**
 *
 */
BewypeJS.Ui.HButtonBox = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.HBox,
    
    initialize: function (params)
    {
        // init parent
        this.parent(params);
    }
});

/**
 *
 */
BewypeJS.Ui.VButtonBoxParser =
{
    parse: function (elementId)
    {
        // use parent parser
        return BewypeJS.Ui.ButtonBoxParser.parse("vertical", elementId);
    },

    swap: function (elementId, widget)
    {
        BewypeJS.Ui.ButtonBoxParser.swap(elementId, widget);
    }
};

/**
 *
 */
BewypeJS.Ui.VButtonBox = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.VBox,
    
    initialize: function (params)
    {
        // init parent
        this.parent(params);
    }
});

