
/**
 *
 */
BewypeJS.Ui.CellLayout = new Class(
{    
    initialize: function (params)
    {
        // basic init
        this.cellRendererList = new Array();
        this.kargsList = new Array();
        this.funcList = new Array();

        // get cellRenderer
        var _cellRenderer = BewypeJS.Utils.getVal(params, "cellRenderer");
        // get kargs (can be null)
        var _kargs = BewypeJS.Utils.getVal(params, "kargs");

        // set the column renderer to the column renderer list
        if (MochiKit.Base.isUndefinedOrNull(_cellRenderer))
        {
            MochiKit.Base.noop();
        }
        else
        {
            // first renderer with no value set
            this.cellRendererList.push(_cellRenderer);
            this.kargsList.push(_kargs);
            this.funcList.push(null);
        }
    },

    /**
     *
     */
    packStart: function (cellRenderer, expand)
    {
        // update renderer list
        this.cellRendererList.unshift(cellRenderer);
        // update karg for coherence reasons
        this.kargsList.unshift({});
        this.funcList.unshift(null);
    },
    
    /**
     *
     */
    packEnd: function (cellRenderer, expand)
    {
        // update renderer list
        this.cellRendererList.push(cellRenderer);
        // update karg for coherence reasons
        this.kargsList.push({});
        this.funcList.push(null);
    },

    /**
     *
     */
    clear: function ()
    {
        MochiKit.Base.noop();
    },

    /**
     *
     */
    getCellRenderers: function ()
    {
        return this.cellRendererList;
    },

    /**
     *
     */
    addAttribute: function (cellRenderer, attribute, columnNum)
    {
        //
        if (MochiKit.Base.keys(cellRenderer).indexOf(attribute) == -1
            || this.cellRendererList.indexOf(cellRenderer) == -1)
        {
            // do nothing
            MochiKit.Base.noop();
        }
        else
        {
            // index in the list
            var position = this.cellRendererList.indexOf(cellRenderer);
            // update kargs for the cellrenderer
            this.kargsList[position][attribute] = columnNum;
        }
    },

    /**
     *
     */
    setAttributes: function (cellRenderer, kargsList)
    {
        // get simple list to iter manually
        var _args = MochiKit.Base.items(kargsList);
        for(var _i=0; _i < _args.length; _i++)
        {
            // parse explicitly params
            var attribute = _args[_i][0];
            var column = _args[_i][1];
            // call common addAttribute function
            this.addAttribute(cellRenderer, attribute, column);
        }
    },

    /**
     *
     */
    setCellDataFunc: function (cellRenderer, func, funcData)
    {
        //
        if (cellRendererList.indexOf(cellRenderer) == -1)
        {
            // do nothing
            MochiKit.Base.noop();
        }
        else
        {
            // index in the list
            var position = this.cellRendererList.indexOf(cellRenderer)
            // update attribute
            this.kargsList[position][attribute] = columnNum;

            // update data func - may be None
            if (MochiKit.Base.isUndefinedOrNull(funcData))
            {
                //
                this.funcList[position] = 
                    MochiKit.Base.partial(func, funcData);
            }
            else
            {
                //
                this.funcList[position] = func;
            }
        }
    }
});

