/**
 * CellRenderer
 */
BewypeJS.Ui.CellRenderer = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.Container,
    
    initialize: function (params)
    {
        // init parent
        this.parent(params);
    }
});

/**
 * CellRenderer
 */
BewypeJS.Ui.CellRendererText = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.CellRenderer,

    initialize: function (params)
    {
        // init parent
        this.parent(params);
        
        // current attributes
        this.editable = null;
        //
        this.markup = null;
        this.text = null;
        this.href = null;
        this.name = null;
    },

    /**
     *
     */
    getDocFactory: function ()
    {
        //
        this.attrs["text"] = this.text;
        this.attrs["alt"] = this.markup;
        this.attrs["name"] = this.name;

        if (this.editable == true)
        {
            // build widget
            var widget = new BewypeJS.Ui.Entry(this.attrs);
        }
        else
        {
            // manage link here - ensure valid link or nothing
            if(MochiKit.Base.isUndefinedOrNull(this.href))
            {
                // get current href
                var _href = BewypeJS.Utils.getVal(this.attrs, "href");
                if(MochiKit.Base.isUndefinedOrNull(_href))
                {
                    MochiKit.Base.noop();
                }
                else
                {
                    // remove previous key
                    delete this.attrs["href"];
                }
            }
            else
            {
                this.attrs["href"] = this.href;
            }
            // build widget
            var widget = new BewypeJS.Ui.Label(this.attrs);
        }

        // return new build factory
        return widget.getDocFactory();
    },

    /**
     *
     */
    setText: function (text)
    {
        this.text = text;
    },

    /**
     *
     */
    getText: function ()
    {
         return this.text;
    },

    /**
     *
     */
    setMarkup: function (markup)
    {
        this.markup = markup;
    },

    /**
     *
     */
    getMarkup: function ()
    {
         return this.markup;
    },

    /**
     *
     */
    setHref: function (href)
    {
        this.href = href;
    },

    /**
     *
     */
    getHref: function ()
    {
         return this.href;
    },

    /**
     *
     */
    setName: function (name)
    {
        this.name = name;
    },

    /**
     *
     */
    getName: function ()
    {
         return this.name;
    }
});

