/**
 *
 */
function _updateDocFactory(docFactory, widget)
{
    //
    var _wElement = widget.getDocFactory();
    // append child
    MochiKit.DOM.appendChildNodes(docFactory, _wElement);
}

/**
 *
 */
function _keepWidget(newWigets, widgetToRemove, widgetToTest)
{
    if (widgetToRemove == widgetToTest)
    {
        // pass
    }
    else
    {
        MochiKit.Base.extend(newWigets, [widgetToTest]);
    }
}

/**
 *
 */
BewypeJS.Ui.Container = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.Widget,    

    initialize: function (params)
    {
        // init parent
        this.parent(params);
        //
        this.borderWidth = BewypeJS.Utils.getVal(params, "borderWidth");
    },

    getDocFactory: function ()
    {
        if (this.widgets.length > 0)
        {
            // 
            var newDocFactory = null;

            if (MochiKit.Base.isUndefinedOrNull(this.docFactory))
            {
                newDocFactory = MochiKit.DOM.DIV(this.attrs, null);
            }
            else
            {
                newDocFactory = this.docFactory;
            }
            //
            var newupdateDocFactoryFunc = MochiKit.Base.partial(
                    _updateDocFactory,
                    newDocFactory
                    );
            //
            MochiKit.Base.map(newupdateDocFactoryFunc, this.widgets);
            //
            return newDocFactory;
        }
        else
        {
            //
            return this.docFactory;
        }
    },

    setBorderWidth: function (borderWidth)
    {
        this.borderWidth = borderWidth;
    },

    getBorderWidth: function ()
    {
        return this.borderWidth;
    },

    add: function (widget)
    {
        // add item to the container
        this.widgets.push(widget);
    },

    remove: function (widget)
    {
        //
        var newWidgets = array();
        //
        var newKeepWidgetFunc = MochiKit.Base.partial(
                _keepWidget,
                newWidgets,
                widget
                );
        //
        MochiKit.Base.map(newKeepWidgetFunc, this.widgets);
        //
        this.widgets = newWidgets;
    },

    getChildren: function ()
    {
        return this.widgets;
    },

    setFocusChild: function (params)
    {
    },

    getFocusChild: function ()
    {
    }
});

