/**
 */
BewypeJS.Ui.Entry = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.Editable,    

    initialize: function (params)
    {
        // init parent
        this.parent(params);

        // get params
        this.text = BewypeJS.Utils.getVal(params, "text");
        this.maxLength = BewypeJS.Utils.getVal(params, "maxLength");
        this.visible = BewypeJS.Utils.getVal(params, "visible");

        // specific attributes
        var _type = BewypeJS.Utils.getVal(params, "type");
        if(MochiKit.Base.isUndefinedOrNull(_type))
        {
            // text by default
            this.attrs["type"] = "text";
        }
        else
        {
            this.attrs["type"] = _type;
        }
        this.attrs["value"] = this.text;
    },

    getDocFactory: function () {
        return MochiKit.DOM.INPUT(this.attrs, this.text);
    },

    setText: function (text) {
        this.attrs["value"] = text;
        this.text = text;
    },

    setMaxLength: function (maxLength) {
        this.maxLength = maxLength;
    },

    getMaxLength: function () {
        return this.maxLength;
    },

    setVisibility: function (visible) {
        this.visible = visible;
    },

    getVisibility: function () {
        return this.visible;
    }
});

