
/**
 *
 */
BewypeJS.Ui.FrameParser =
{
    parse: function (elementId)
    {
        var _params = BewypeJS.Ui.WidgetParser._parse(elementId);
        
        if(MochiKit.Base.isUndefinedOrNull(_params))
        {
            return null;
        }
        else
        {
            // get element first
            var _widgetElmt = MochiKit.DOM.getElement(elementId);
            var _className = BewypeJS.Utils.getVal(_params, "class");
            // get label element
            var _labelElmt = MochiKit.DOM.getFirstElementByTagAndClassName(
                    "h1", _className, _widgetElmt);
            // update params
            _params["label"] = _labelElmt.innerHTML;

            return new BewypeJS.Ui.Frame(_params);
        }
    },

    swap: function (elementId, widget)
    {
        BewypeJS.Ui.WidgetParser.swap(elementId, widget);
    }
};

/**
 *
 */
BewypeJS.Ui.Frame = new Class(
{
    // parent class
    Extends: BewypeJS.Ui.Bin,    

    initialize: function (params)
    {
        // init parent
        this.parent(params);
        //
        this.shadowType = BewypeJS.Utils.getVal(params, "shadowType");
        //
        this.xalign = BewypeJS.Utils.getVal(params, "xalign");
        this.yalign = BewypeJS.Utils.getVal(params, "yalign");

        // init factory
        this.docFactory = MochiKit.DOM.DIV(this.attrs, null);

        //
        this.label = BewypeJS.Utils.getVal(params, "label");
        this.labelWidget = BewypeJS.Utils.getVal(params, "labelWidget");

        if(MochiKit.Base.isUndefinedOrNull(this.label)
            && MochiKit.Base.isUndefinedOrNull(this.labelWidget))
        {
            MochiKit.Base.noop();
        }
        else if(MochiKit.Base.isUndefinedOrNull(this.label))
        {
            this.setLabelWidget(this.labelWidget);
        }
        else
        {
            this.setLabel(this.label);
        }
    },

    setLabel: function (label)
    {
        // always update label value
        this.label = label;

        if(MochiKit.Base.isUndefinedOrNull(this.label))
        {
            MochiKit.Base.noop();
        }
        else
        {
            var _class = BewypeJS.Utils.getVal(this.attrs, "class");
            // prepare label attrs
            var _params = {
                    "class": _class,
                    "text": this.label,
                    "name": _class.toLowerCase(),
                    "tag": MochiKit.DOM.H1
                };
            // create new label widget 
            var _labelWidget = new BewypeJS.Ui.Label(_params);
            this.setLabelWidget(_labelWidget);
        }
    },

    getLabel: function ()
    {
        return this.label;
    },

    setLabelWidget: function (labelWidget)
    {
        this.labelWidget = labelWidget;
        // update factory
        this.docFactory = MochiKit.DOM.DIV(this.attrs, null);
        // append label
        MochiKit.DOM.appendChildNodes(
                this.docFactory, this.labelWidget.getDocFactory());
    },

    getLabelWidget: function ()
    {
        return this.labelWidget;
    },

    setLabelAlign: function (align)
    {
        this.xalign = align["xalign"];
        this.yalign = align["yalign"];
    },

    getLabelAlign: function ()
    {
        return {
            "xalign": xalign,
            "yalign": yalign
        };
    },

    setShadowType: function (shadowType)
    {
        this.shadowType = shadowType;
    },

    getShadowType: function ()
    {
        return shadowType;
    }
});

