
/**
 *
 */
BewypeJS.Ui.WidgetParser =
{
    _parse: function (elementId)
    {
        // get element first
        var _widgetElmt = MochiKit.DOM.getElement(elementId);

        if(MochiKit.Base.isUndefinedOrNull(_widgetElmt))
        {
            return null;
        }
        else
        {
            // init params
            var _params = {};
            // get id
            _params["id"] = _widgetElmt.id;
            // get class
            _params["class"] = _widgetElmt.className;
            // get name
            _params["name"] = _widgetElmt.name;
            // get label
            _params["label"] = _widgetElmt.value;
            // get node attributes
            _params["href"] = BewypeJS.Utils.getAttrVal(_widgetElmt, "href");
            _params["markup"] = BewypeJS.Utils.getAttrVal(_widgetElmt, "alt");
            // get stock    -| not used yet
            _params["stock"] = null;

            // return new button
            return _params;
        }
    },

    parse: function (elementId)
    {
        var _params = BewypeJS.Ui.WidgetParser._parse(elementId);
        
        if(MochiKit.Base.isUndefinedOrNull(_params))
        {
            return null;
        }
        else
        {
            // noop - should be overiden
        }
    },

    swap: function (elementId, widget)
    {
        // get element first
        var _widgetElmt = MochiKit.DOM.getElement(elementId);

        if(MochiKit.Base.isUndefinedOrNull(_widgetElmt))
        {
            // do nothing
            MochiKit.Base.noop();
        }
        else
        {
            // do swap
            MochiKit.DOM.swapDOM(_widgetElmt, widget.getDocFactory());
        }
    }
};

/**
 *
 */
BewypeJS.Ui.Widget = new Class(
    {
        initialize: function (params) {
            //
            this.parent = params["parent"];
            //
            this.attrs = {};
            // only set id if not null
            BewypeJS.Utils.setVal(this.attrs, "id",
                BewypeJS.Utils.getVal(params, "id"));
            // only set class if not null
            BewypeJS.Utils.setVal(this.attrs, "class",
                BewypeJS.Utils.getVal(params, "class"));
            //
            this.widgets = [];
            this.docFactory = null;
        },

        getDocFactory: function () {
            return this.docFactory;
        },

        realize: function () {
            // pass
        },
        
        setParent: function (parent) {
            this.parent = parent;
        },

        getParent: function () {
            return this.parent;
        }
    }
);
