
/**
 *
 */
BewypeJS.Utils.List =
{
    /**
     *
     */
    _getListItem: function (elementId, className, renderCb, modelRow, serial)
    {
        // line item attrs
        var _attrs = {
            "id": elementId + "Item_" + serial,
            "class": className,
            };

        // hidden value
        var _hiddenAttrs = {
                "type": "hidden",
                "value": modelRow[modelRow.length - 1]
            };
        var _hiddenElmt = MochiKit.DOM.INPUT(_hiddenAttrs, null);

        if(MochiKit.Base.isUndefinedOrNull(renderCb))
        {
            // build list
            return MochiKit.DOM.LI(_attrs, [modelRow[0], _hiddenElmt]);
        }
        else
        {
            // build list
            return MochiKit.DOM.LI(
                    _attrs,
                    [renderCb(className, modelRow), _hiddenElmt]
                    );
        }
    },

    /**
     *
     */
    _getList: function (elementId, className, modelList, renderCb)
    {
        // prepare getter func
        var _getListItemFunc = MochiKit.Base.partial(
                BewypeJS.Utils.List._getListItem,
                elementId,
                className,
                renderCb
                );

        
        // init list serials int
        var _serialList = MochiKit.Base.keys(modelList);

        // get item list
        var _itemElmtList = MochiKit.Base.map(
                _getListItemFunc, modelList, _serialList);
        
        // new list div attrs
        var _attrs = {
            "id": elementId,
            "class": className
            };

        // build list
        var _sortableListElmt = MochiKit.DOM.UL(_attrs, _itemElmtList);

        // return list
        return _sortableListElmt;
    },

    /**
     * 
     */
    updateSortableList: function (elementId, modelList, renderCb, onUpdateCb)
    {
        // add info
        var _listDivElmt = MochiKit.DOM.getElement(elementId);
        // ensure a sortable Id
        var _sortableId = _listDivElmt.id + "Sortable"
        // get list
        var _sortableListElmt = BewypeJS.Utils.List._getList(
                _sortableId, _listDivElmt.className, modelList, renderCb);
        // new list div attrs
        var _attrs = {
            "id": _listDivElmt.id,
            "class": _listDivElmt.className
            };
        // create new div
        _newListDivElmt = MochiKit.DOM.DIV(_attrs, _sortableListElmt);
        // replace with new list
        MochiKit.DOM.swapDOM(_listDivElmt, _newListDivElmt);
        //
        if(MochiKit.Base.isUndefinedOrNull(onUpdateCb))
        { 
            // set callbacks
            MochiKit.Sortable.Sortable.create(_sortableId);
        }
        else
        {   
            // set callbacks
            MochiKit.Sortable.Sortable.create(
                        _sortableId,
                        {
                            "onUpdate" : onUpdateCb
                        }
                    );
        }
    }
}
