#!/bin/sh
# make_docs.sh

# Html
html() {
    # sphinx task
    cd sphinx
    make clean
    make html

    # epydoc task
    cd ..
    cd epydoc
    epydoc --config=config.ini
}

# Clean
clean() {
    if [ -e output ]
    then
        cd sphinx
        make clean
        cd ..
        rmdir output
    fi
}

### main logic ###
case "$1" in
  html)
        html
        ;;
  clean)
        clean
        ;;
  *)
        echo $"Usage: $0 {html|clean}"
        exit 1
esac

exit 0

